/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.stringtemplatesexamples;

import static java.lang.StringTemplate.STR;
import static java.lang.StringTemplate.RAW;

/**
 *
 * @author omozegieaziegbe
 */
public class StringTemplatesExamples {

    public static void main(String[] args) {
        
        String name = "Alice";	
        
        StringTemplate st = RAW."Greetings \{name}.";
        String message = STR.process(st);
        System.out.println("" + message);

        Formatting numbers and strings
        String info = FMT. "%d items found for %s", 10, "search term";
        System.out.println(info);  // Output: 10 items found for search term

        String name = "John";
        String age = "30";

        // Greeting with variable interpolation
        String greeting = STR. "Hello, \{name}! You are \{age} years old.";
        System.out.println(greeting); // Output: Hello, John! You are 30 years old.

        // Multi-line greeting
        String message = STR. """
        Welcome, \{name}!

        This is a multi-line message
        using the STR processor.
        """;
        System.out.println(message);

        String name = "Alice";
        String greeting = STR. "Hello, \{name}!";
        System.out.println(greeting); // Output: Hello, Alice! 

        int age = 25;
        String info = STR. "You are \{age * 365} days old."; // Performs calculation
        System.out.println("" + info);
        
        LocalDate today = LocalDate.now();
        String formattedDate = STR. "Today's date is \{today.format(DateTimeFormatter.ISO_DATE)}"; // Calls a method
        System.out.println("" + formattedDate);
        
        String product = "T-Shirt";
        double price = 19.99;
        String discount = STR. "The \{product.toUpperCase()} is on sale for \{price * 0.9}"; // Nested expressions
        System.out.println("" + discount);
    }
}
